
# PlanAhead Launch Script for Post PAR Floorplanning, created by Project Navigator

create_project -name Example2 -dir "/home/admin/Zarlink_ZestET1_Basissation/planAhead_run_1" -part xc3s1400aft256-5
set srcset [get_property srcset [current_run -impl]]
set_property design_mode GateLvl $srcset
set_property edif_top_file "/home/admin/Zarlink_ZestET1_Basissation/Example2.ngc" [ get_property srcset [ current_run ] ]
add_files -norecurse { {/home/admin/Zarlink_ZestET1_Basissation} {ipcore_dir} }
add_files "/home/admin/Zarlink_ZestET1_Basissation/EchoFIFO.ncf" "ipcore_dir/FIFO_16Bit_1000BlockCheck.ncf" "ipcore_dir/NetworkOutgoingPaketProcessingFIFO.ncf" "ipcore_dir/FIFO_30Bit_1000BlockCheck.ncf" "ipcore_dir/FIFO_TIMEWARP.ncf" "ipcore_dir/SPI_Slow2Fast.ncf" "ipcore_dir/FIFO_IO_Network.ncf" "ipcore_dir/AutoPoller_FIFO_16Bit.ncf" "ipcore_dir/FIFO_SINGLECLOCK.ncf" "ipcore_dir/SPI_Fast2Slow.ncf" "ipcore_dir/EchoFIFO.ncf" "ipcore_dir/PacketDecodingFIFO.ncf" -fileset [get_property constrset [current_run]]
set_param project.paUcfFile  "ZestET1.ucf"
add_files "ZestET1.ucf" -fileset [get_property constrset [current_run]]
open_netlist_design
read_xdl -file "/home/admin/Zarlink_ZestET1_Basissation/Example2.ncd"
if {[catch {read_twx -name results_1 -file "/home/admin/Zarlink_ZestET1_Basissation/Example2.twx"} eInfo]} {
   puts "WARNING: there was a problem importing \"/home/admin/Zarlink_ZestET1_Basissation/Example2.twx\": $eInfo"
}
